(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http'), require('rxjs/operators'), require('@yukawa/chain-base-angular-client'), require('lodash'), require('@yukawa/chain-base-angular-domain'), require('@yukawa/chain-main-angular-core'), require('@angular/common'), require('@ngx-translate/core')) :
    typeof define === 'function' && define.amd ? define('@yukawa/chain-crm-angular-core', ['exports', '@angular/core', '@angular/common/http', 'rxjs/operators', '@yukawa/chain-base-angular-client', 'lodash', '@yukawa/chain-base-angular-domain', '@yukawa/chain-main-angular-core', '@angular/common', '@ngx-translate/core'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.yukawa = global.yukawa || {}, global.yukawa["chain-crm-angular-core"] = {}), global.ng.core, global.ng.common.http, global.rxjs.operators, global.i2, global._, global.chainBaseAngularDomain, global.chainMainAngularCore, global.ng.common, global.i1$1));
})(this, (function (exports, i0, i1, operators, i2, _, chainBaseAngularDomain, chainMainAngularCore, common, i1$1) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);
    var i2__namespace = /*#__PURE__*/_interopNamespace(i2);
    var ___default = /*#__PURE__*/_interopDefaultLegacy(_);
    var i1__namespace$1 = /*#__PURE__*/_interopNamespace(i1$1);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    function __createBinding(o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    }
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                exports[p] = m[p];
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    result[k] = mod[k];
        result.default = mod;
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var AccountService = /** @class */ (function (_super) {
        __extends(AccountService, _super);
        function AccountService(http, configService) {
            return _super.call(this, http, configService) || this;
        }
        AccountService.prototype.queryAccount = function (filter) {
            return this.query(this.formatServiceUrl('/query'), filter);
        };
        AccountService.prototype.queryAccountsAsList = function (partnerType, keyword) {
            return this.queryAccount({
                pager: { pageSize: 100, firstResult: 0 },
                keyword: keyword,
                partnerType: partnerType
            }).pipe(operators.map(function (value) { return value.items; }));
        };
        AccountService.prototype.mergeAccount = function (partner) {
            return this.edit(this.formatServiceUrl("/merge"), partner, { method: 'post' });
        };
        AccountService.prototype.collectionsPut = function (partner) {
            return this.http.post(this.formatServiceUrl('/collections/put'), partner);
        };
        AccountService.prototype.collectionsRemove = function (partner) {
            return this.http.post(this.formatServiceUrl('/collections/remove'), partner);
        };
        AccountService.prototype.collectionsAppend = function (partner) {
            return this.http.post(this.formatServiceUrl('/collections/append'), partner);
        };
        AccountService.prototype.loadAccount = function (id) {
            var _this = this;
            return this.load(this.formatServiceUrl('') + "/?key=" + id)
                .pipe(operators.map(function (value) { return _this.checkNotNull(value); }));
        };
        AccountService.prototype.saveAccount = function (account, type) {
            if (type === void 0) { type = "create"; }
            return this.edit(this.formatServiceUrl("/" + type), account, { method: 'post' });
        };
        AccountService.prototype.deleteAccount = function (id) {
            return this.http.delete(this.formatServiceUrl('') + "/?key=" + id);
        };
        AccountService.prototype.newAccount = function () {
            var _this = this;
            return this.http.post("" + this.formatServiceUrl('/new'), {})
                .pipe(operators.map(function (value) { return _this.checkNotNull(value); }));
        };
        AccountService.prototype.export = function (filter) {
            var opts = {
                headers: new i1.HttpHeaders({
                    'Content-Type': 'application/json'
                    //'Accept': 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'
                })
            };
            return this.download("" + this.formatServiceUrl('/export'), filter, opts);
        };
        AccountService.prototype.importPartners = function (data) {
            return this.http.post("" + this.formatServiceUrl('/import'), data);
        };
        AccountService.prototype.formatServiceUrl = function (path) {
            if (path === void 0) { path = ''; }
            return this.configService.formatUrl("partnerUrl") + path;
        };
        return AccountService;
    }(i2.RestAspect));
    /** @nocollapse */ AccountService.ɵfac = function AccountService_Factory(t) { return new (t || AccountService)(i0__namespace.ɵɵinject(i0.forwardRef(function () { return i1.HttpClient; })), i0__namespace.ɵɵinject(i0.forwardRef(function () { return i2.ConfigService; }))); };
    /** @nocollapse */ AccountService.ɵprov = i0__namespace.ɵɵdefineInjectable({ token: AccountService, factory: AccountService.ɵfac, providedIn: 'root' });
    /*@__PURE__*/ (function () {
        i0__namespace.ɵsetClassMetadata(AccountService, [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }], function () {
            return [{ type: i1__namespace.HttpClient, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i1.HttpClient; })]
                        }] }, { type: i2__namespace.ConfigService, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i2.ConfigService; })]
                        }] }];
        }, null);
    })();
    var RelationService = /** @class */ (function (_super) {
        __extends(RelationService, _super);
        function RelationService(http, configService) {
            return _super.call(this, http, configService) || this;
        }
        RelationService.prototype.searchRelation = function (filter) {
            return this.search(this.formatServiceUrl('/search'), filter);
        };
        RelationService.prototype.queryRelation = function (filter) {
            return this.query(this.formatServiceUrl('/query'), filter);
        };
        RelationService.prototype.loadRelation = function (id) {
            var _this = this;
            return this.load(this.formatServiceUrl('') + "/?key=" + id)
                .pipe(operators.map(function (value) { return _this.checkNotNull(value); }));
        };
        RelationService.prototype.saveRelation = function (relation, type) {
            if (type === void 0) { type = "create"; }
            return this.edit(this.formatServiceUrl("/" + type), relation, { method: 'post' });
        };
        RelationService.prototype.deleteRelation = function (id) {
            return this.http.delete(this.formatServiceUrl('') + "/?key=" + id);
        };
        RelationService.prototype.traverseRelations = function (partnerId, role, traversalDir) {
            return this.http.get(this.formatServiceUrl('/traverse') + "?partnerId=" + partnerId + "&role=" + role + "&traversalDir=" + traversalDir);
        };
        RelationService.prototype.formatServiceUrl = function (path) {
            if (path === void 0) { path = ''; }
            return this.configService.formatUrl("relationUrl") + path;
        };
        return RelationService;
    }(i2.RestAspect));
    /** @nocollapse */ RelationService.ɵfac = function RelationService_Factory(t) { return new (t || RelationService)(i0__namespace.ɵɵinject(i0.forwardRef(function () { return i1.HttpClient; })), i0__namespace.ɵɵinject(i0.forwardRef(function () { return i2.ConfigService; }))); };
    /** @nocollapse */ RelationService.ɵprov = i0__namespace.ɵɵdefineInjectable({ token: RelationService, factory: RelationService.ɵfac, providedIn: 'root' });
    /*@__PURE__*/ (function () {
        i0__namespace.ɵsetClassMetadata(RelationService, [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }], function () {
            return [{ type: i1__namespace.HttpClient, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i1.HttpClient; })]
                        }] }, { type: i2__namespace.ConfigService, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i2.ConfigService; })]
                        }] }];
        }, null);
    })();
    var ContactLogService = /** @class */ (function (_super) {
        __extends(ContactLogService, _super);
        function ContactLogService(http, configService) {
            return _super.call(this, http, configService, configService.formatUrl("contactLogUrl")) || this;
        }
        ContactLogService.prototype.searchContactLog = function (filter) {
            return this.search(this.formatServiceUrl('/search'), filter);
        };
        ContactLogService.prototype.queryContactLog = function (filter) {
            return this.query(this.formatServiceUrl('/query'), filter);
        };
        ContactLogService.prototype.loadContactLog = function (id) {
            var _this = this;
            return this.load(this.formatServiceUrl('') + "/?key=" + id)
                .pipe(operators.map(function (value) { return _this.checkNotNull(value); }));
        };
        ContactLogService.prototype.saveContactLog = function (contactLog, type) {
            if (type === void 0) { type = "create"; }
            return this.edit(this.formatServiceUrl("/" + type), contactLog, { method: 'post' });
        };
        ContactLogService.prototype.deleteContactLog = function (id) {
            return this.http.delete(this.formatServiceUrl('') + "/?key=" + id);
        };
        return ContactLogService;
    }(i2.RestAspect));
    /** @nocollapse */ ContactLogService.ɵfac = function ContactLogService_Factory(t) { return new (t || ContactLogService)(i0__namespace.ɵɵinject(i0.forwardRef(function () { return i1.HttpClient; })), i0__namespace.ɵɵinject(i0.forwardRef(function () { return i2.ConfigService; }))); };
    /** @nocollapse */ ContactLogService.ɵprov = i0__namespace.ɵɵdefineInjectable({ token: ContactLogService, factory: ContactLogService.ɵfac, providedIn: 'root' });
    /*@__PURE__*/ (function () {
        i0__namespace.ɵsetClassMetadata(ContactLogService, [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }], function () {
            return [{ type: i1__namespace.HttpClient, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i1.HttpClient; })]
                        }] }, { type: i2__namespace.ConfigService, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i2.ConfigService; })]
                        }] }];
        }, null);
    })();

    exports.PartnerType = void 0;
    (function (PartnerType) {
        PartnerType["COMPANY"] = "company";
        PartnerType["PERSON"] = "person";
    })(exports.PartnerType || (exports.PartnerType = {}));
    exports.ContactLogStatus = void 0;
    (function (ContactLogStatus) {
        ContactLogStatus["NEW"] = "New";
        ContactLogStatus["DONE"] = "Done";
        ContactLogStatus["ARCHIVED"] = "Archived";
        ContactLogStatus["PENDING"] = "Pending";
    })(exports.ContactLogStatus || (exports.ContactLogStatus = {}));
    var partnerTypes$1 = [];
    var contactLogStatus = [];
    for (var status in exports.ContactLogStatus) {
        contactLogStatus.push(exports.ContactLogStatus[status]);
    }
    for (var n$2 in exports.PartnerType) {
        partnerTypes$1.push(exports.PartnerType[n$2]);
    }

    /*
    export interface RelationFilter extends TableFilter {
        keyword?: string
        partnerId?: string
        partnerTargetId?: string
        partnerSourceId?: string
        targetOrSourceIds?: string[]
        role?: string;
        //"partnerTargetId\", \"orderBy\", \"role\", \"relationId\", \"keyword\", \"partnerSourceId\
    }

    export interface ContactLogFilter extends TableFilter {
        keyword?: string
        partnerId?: string
        communicationChannel?: string
        participantId?: string
        //\"timeout\", \"status\", \"pager\", \"orderBy\", \"keyword\", \"communicationChannel\", \"orderDir\", \"contactLogId\"
    }
    */

    var withType = function (partner, type) { return partner.partnerType === type; };
    var withId = function (partner, id) { return partner.partnerId === id; };
    var sortByCompanyName = function (p1, p2) {
        if (p1.companyName && p2.companyName) {
            return p1.companyName.localeCompare(p2.companyName);
        }
        return 0;
    };
    var sortByLastName = function (p1, p2) {
        if (p1.lastName && p2.lastName) {
            return p1.lastName.localeCompare(p2.lastName);
        }
        return 0;
    };
    var AccountUtilities = /** @class */ (function () {
        function AccountUtilities() {
        }
        AccountUtilities.getPartnerById = function (partners, partnerId) {
            var ifExist = partners.find(function (val) { return val.partnerId === partnerId; });
            return ifExist;
        };
        AccountUtilities.getDisplayName = function (partner, partnerType) {
            if (partner && partner.partnerType) {
                return partner.partnerType === exports.PartnerType.COMPANY ? partner.companyName : partner.firstName + ' ' + partner.lastName;
            }
            if (partnerType) {
                return partnerType === exports.PartnerType.COMPANY.toString() ? partner.companyName : partner.firstName + ' ' + partner.lastName;
            }
            return "";
        };
        AccountUtilities.compareWith = function (partner1, partner2) {
            return partner1 && partner2 ? partner1.partnerId === partner2.partnerId : -1;
        };
        AccountUtilities.buildPartnerInfo = function (partner) {
            var subset = (function (_a) {
                var companyName = _a.companyName, email = _a.email, firstName = _a.firstName, lastName = _a.lastName, partnerId = _a.partnerId, shortName = _a.shortName;
                return ({
                    companyName: companyName,
                    email: email,
                    firstName: firstName,
                    lastName: lastName,
                    partnerId: partnerId,
                    shortName: shortName
                });
            });
            return subset(partner);
        };
        AccountUtilities.filterAccounts = function (accounts, subject, filterCtrl) {
            if (!accounts) {
                return;
            }
            // get the search keyword
            var search = filterCtrl.value;
            if (!search) {
                subject.next(accounts.slice());
                return;
            }
            else {
                search = search.toLowerCase();
            }
            // filter the accounts
            subject.next(accounts.filter(function (account) {
                if (account.companyName) {
                    return account.companyName.toLowerCase().indexOf(search) > -1;
                }
                if (account.firstName && account.lastName) {
                    return account.firstName.toLowerCase().indexOf(search) > -1 || account.lastName.toLowerCase().indexOf(search) > -1;
                }
            }));
        };
        return AccountUtilities;
    }());

    var AddressUtils = /** @class */ (function () {
        function AddressUtils() {
        }
        AddressUtils.findAddressByType = function (address, type) {
            var _this = this;
            var _address = address.filter(function (val) { return val.type != null; }).find(function (val) { return val.type === _this.TYPE_INVOICE; });
            return _address;
        };
        AddressUtils.getFormGroup = function (fb, initial, validators) {
            var group = fb.group({
                type: [null, null],
                street: [null, null],
                houseNumber: [null, null],
                countryCode: [null, null],
                city: [null, null],
                zipCode: [null, null],
                desc: [null, null]
            });
            if (initial) {
                group.patchValue(initial);
            }
            return group;
        };
        AddressUtils.addAddressToFormArray = function (fa, fb, initial) {
            var formArray = fa;
            formArray.push(this.getFormGroup(fb, initial));
        };
        AddressUtils.addAndGetAddress = function (fa, fb, initial) {
            var formArray = fa;
            var group = this.getFormGroup(fb, initial);
            formArray.push(group);
            return group;
        };
        return AddressUtils;
    }());
    AddressUtils.TYPE_INVOICE = "INVOICE";

    var PartnerType;
    (function (PartnerType) {
        PartnerType["COMPANY"] = "company";
        PartnerType["PERSON"] = "person";
    })(PartnerType || (PartnerType = {}));
    var partnerTypes = [];
    for (var n$1 in PartnerType) {
        partnerTypes.push(PartnerType[n$1]);
    }
    // export interface RelationConfig {
    //     source: PartnerType;
    //     target: PartnerType;
    //     role: string;
    //     relation: string; // designation  from source to target
    //     inverseRelation: string;
    //     perspective?: 'source' | 'target';
    // }

    // configuration of possible roles in a relation
    // the convention is that the relation represents the natural understanding of: source - role - target
    var relationsConfig = [
        {
            source: PartnerType.COMPANY,
            target: PartnerType.COMPANY,
            role: "isHoldingOf",
            relation: "Is holding of",
            inverseRelation: "Is subsidiary of"
        },
        {
            source: PartnerType.PERSON,
            target: PartnerType.COMPANY,
            relation: "is employee of",
            inverseRelation: "employs",
            role: "isEmployeeOf"
        },
        {
            source: PartnerType.COMPANY,
            target: PartnerType.COMPANY,
            relation: "is supplier of",
            inverseRelation: "has supplier",
            role: "isSupplierOf",
        },
    ];
    exports.RelationRole = void 0;
    (function (RelationRole) {
        RelationRole["HOLDING_OF"] = "isHoldingOf";
        RelationRole["EMPLOYEE_OF"] = "isEmployeeOf";
        RelationRole["SUPPLIER_OF"] = "isSupplierOf";
    })(exports.RelationRole || (exports.RelationRole = {}));
    var relationRoles = [];
    for (var n in exports.RelationRole) {
        relationRoles.push(PartnerType[n]);
    }
    var RelationConfigService = /** @class */ (function () {
        function RelationConfigService() {
        }
        // -----------------------------------------------------------------------------------------------------
        // @ Utility Methods
        // -----------------------------------------------------------------------------------------------------
        /**
         *
         * @param type1
         * @param type2
         * @returns all relation configs where type1 -> type2 or type2 -> type1
         */
        RelationConfigService.getRelationConfigsUndirected = function (type1, type2) {
            var _config = relationsConfig.filter((function (value) { return (value.source === type1 && value.target === type2) ||
                (value.source === type2 && value.target === type1); }));
            return _config;
        };
        /**
         *
         * @param source
         * @param target
         * @returns all relation configs that exist from source type to target type
         */
        RelationConfigService.getRelationConfigsDirected = function (source, target) {
            var _relationConfig = relationsConfig.filter((function (value) { return (value.source === source && value.target === target); }));
            return _relationConfig;
        };
        /**
         *
         * @param role
         * @returns the unique RelationConfig for a role
         */
        RelationConfigService.getRelationConfigForRole = function (role) {
            var _relationConfig = relationsConfig.filter(function (value) { return value.role === role; }).find(function (x) { return x !== undefined; });
            return _relationConfig;
        };
        /**
         *
         * @param rel relation
         * @param partnerId the partner that appears either as source or as target in rel
         * @returns returns the relation designation
         */
        RelationConfigService.getDisplayedRelation = function (rel, partnerId) {
            var config = this.getRelationConfigForRole(rel.role);
            return rel.sourcePartner.partnerId === partnerId ? config.relation : config.inverseRelation;
        };
        /**
         *
         * @param type
         * @returns all configurations including type either as source or target
         */
        RelationConfigService.getRelationConfigsIncludingType = function (type) {
            var e_1, _a;
            var configs = relationsConfig.filter(function (value) { return value.source === type || value.target === type; });
            try {
                for (var configs_1 = __values(configs), configs_1_1 = configs_1.next(); !configs_1_1.done; configs_1_1 = configs_1.next()) {
                    var config = configs_1_1.value;
                    if (config.target === type) {
                        config.perspective = 'target';
                    }
                    else {
                        config.perspective = 'source';
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (configs_1_1 && !configs_1_1.done && (_a = configs_1.return)) _a.call(configs_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return configs;
        };
        /**
         *
         * @param type
         * @returns all configurations including type either source
         */
        RelationConfigService.getRelationConfigsIncludingTypeAsSource = function (type) {
            var e_2, _a;
            var res = ___default["default"].cloneDeep((relationsConfig.filter(function (value) { return value.source === type; })));
            try {
                for (var res_1 = __values(res), res_1_1 = res_1.next(); !res_1_1.done; res_1_1 = res_1.next()) {
                    var val = res_1_1.value;
                    val.perspective = 'source';
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (res_1_1 && !res_1_1.done && (_a = res_1.return)) _a.call(res_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
            return res;
        };
        /**
         *
         * @param type
         * @returns all configurations including type either source
         */
        RelationConfigService.getRelationConfigsIncludingTypeAsTarget = function (type) {
            var e_3, _a;
            var res = ___default["default"].cloneDeep(relationsConfig.filter(function (value) { return value.target === type; }));
            try {
                for (var res_2 = __values(res), res_2_1 = res_2.next(); !res_2_1.done; res_2_1 = res_2.next()) {
                    var val = res_2_1.value;
                    val.perspective = 'target';
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (res_2_1 && !res_2_1.done && (_a = res_2.return)) _a.call(res_2);
                }
                finally { if (e_3) throw e_3.error; }
            }
            return res;
        };
        return RelationConfigService;
    }());

    /**
    *	@generator rest2ts
    *	javaType: inc.yukawa.chain.crm.partner.service.rest.ContactLogRest <br/>
    */
    var ContactLogRest = /** @class */ (function () {
        function ContactLogRest(httpService) {
            this.httpService = httpService;
        }
        ContactLogRest.prototype.queryMyActivities = function (filter) {
            var headers = new i1.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.post('/contactlogs/queryMyActivities', filter, { headers: headers });
        };
        ContactLogRest.prototype.queryMyToDos = function (filter) {
            var headers = new i1.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.post('/contactlogs/queryMyToDos', filter, { headers: headers });
        };
        return ContactLogRest;
    }());
    /** @nocollapse */ ContactLogRest.ɵfac = function ContactLogRest_Factory(t) { return new (t || ContactLogRest)(i0__namespace.ɵɵinject(i1__namespace.HttpClient)); };
    /** @nocollapse */ ContactLogRest.ɵprov = i0__namespace.ɵɵdefineInjectable({ token: ContactLogRest, factory: ContactLogRest.ɵfac });
    /*@__PURE__*/ (function () {
        i0__namespace.ɵsetClassMetadata(ContactLogRest, [{
                type: i0.Injectable
            }], function () { return [{ type: i1__namespace.HttpClient }]; }, null);
    })();
    /**
    *	@generator rest2ts
    *	javaType: inc.yukawa.chain.crm.partner.service.rest.PartnerImportRest <br/>
    */
    var PartnerImportRest = /** @class */ (function () {
        function PartnerImportRest(httpService) {
            this.httpService = httpService;
        }
        PartnerImportRest.prototype.importPartners = function () {
            return this.httpService.post('/partners/import', null);
        };
        return PartnerImportRest;
    }());
    /** @nocollapse */ PartnerImportRest.ɵfac = function PartnerImportRest_Factory(t) { return new (t || PartnerImportRest)(i0__namespace.ɵɵinject(i1__namespace.HttpClient)); };
    /** @nocollapse */ PartnerImportRest.ɵprov = i0__namespace.ɵɵdefineInjectable({ token: PartnerImportRest, factory: PartnerImportRest.ɵfac });
    /*@__PURE__*/ (function () {
        i0__namespace.ɵsetClassMetadata(PartnerImportRest, [{
                type: i0.Injectable
            }], function () { return [{ type: i1__namespace.HttpClient }]; }, null);
    })();
    /**
    *	@generator rest2ts
    *	javaType: inc.yukawa.chain.crm.partner.service.rest.PartnerRest <br/>
    */
    var PartnerRest = /** @class */ (function () {
        function PartnerRest(httpService) {
            this.httpService = httpService;
        }
        PartnerRest.prototype.mergeCollectionAppend = function (entity) {
            var headers = new i1.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.post('/partners/collections/append', entity, { headers: headers });
        };
        PartnerRest.prototype.mergeCollectionRemove = function (entity) {
            var headers = new i1.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.post('/partners/collections/remove', entity, { headers: headers });
        };
        /**
        *	partner template (will not be saved)
        */
        PartnerRest.prototype.newPartner = function () {
            return this.httpService.post('/partners/new', null);
        };
        PartnerRest.prototype.putCollection = function (entity) {
            var headers = new i1.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.post('/partners/collections/put', entity, { headers: headers });
        };
        PartnerRest.prototype.putMany = function (entities) {
            var headers = new i1.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.post('/partners/putMany', entities, { headers: headers });
        };
        PartnerRest.prototype.uploadImage = function (partnerId) {
            return this.httpService.post('/partners/uploadImage/' + partnerId + '', null);
        };
        return PartnerRest;
    }());
    /** @nocollapse */ PartnerRest.ɵfac = function PartnerRest_Factory(t) { return new (t || PartnerRest)(i0__namespace.ɵɵinject(i1__namespace.HttpClient)); };
    /** @nocollapse */ PartnerRest.ɵprov = i0__namespace.ɵɵdefineInjectable({ token: PartnerRest, factory: PartnerRest.ɵfac });
    /*@__PURE__*/ (function () {
        i0__namespace.ɵsetClassMetadata(PartnerRest, [{
                type: i0.Injectable
            }], function () { return [{ type: i1__namespace.HttpClient }]; }, null);
    })();
    /**
    *	@generator rest2ts
    *	javaType: inc.yukawa.chain.crm.partner.service.rest.PartnerTemplateRest <br/>
    */
    var PartnerTemplateRest = /** @class */ (function () {
        function PartnerTemplateRest(httpService) {
            this.httpService = httpService;
        }
        PartnerTemplateRest.prototype.delete = function () {
            return this.httpService.post('/partner-templates/delete', null);
        };
        PartnerTemplateRest.prototype.load = function () {
            return this.httpService.get('/partner-templates/');
        };
        PartnerTemplateRest.prototype.put = function (entity) {
            var headers = new i1.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.post('/partner-templates/put', entity, { headers: headers });
        };
        return PartnerTemplateRest;
    }());
    /** @nocollapse */ PartnerTemplateRest.ɵfac = function PartnerTemplateRest_Factory(t) { return new (t || PartnerTemplateRest)(i0__namespace.ɵɵinject(i1__namespace.HttpClient)); };
    /** @nocollapse */ PartnerTemplateRest.ɵprov = i0__namespace.ɵɵdefineInjectable({ token: PartnerTemplateRest, factory: PartnerTemplateRest.ɵfac });
    /*@__PURE__*/ (function () {
        i0__namespace.ɵsetClassMetadata(PartnerTemplateRest, [{
                type: i0.Injectable
            }], function () { return [{ type: i1__namespace.HttpClient }]; }, null);
    })();
    /**
    *	@generator rest2ts
    *	javaType: inc.yukawa.chain.crm.partner.service.rest.RelationRest <br/>
    */
    var RelationRest = /** @class */ (function () {
        function RelationRest(httpService) {
            this.httpService = httpService;
        }
        RelationRest.prototype.putMany = function (entities) {
            var headers = new i1.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.post('/relations/putMany', entities, { headers: headers });
        };
        RelationRest.prototype.traverseRelations = function (partnerId, role, traversalDir) {
            var e_1, _a;
            var queryParamsList = [];
            queryParamsList.push({ name: 'partnerId', value: partnerId });
            queryParamsList.push({ name: 'role', value: role });
            queryParamsList.push({ name: 'traversalDir', value: traversalDir });
            var params = new i1.HttpParams();
            try {
                for (var queryParamsList_1 = __values(queryParamsList), queryParamsList_1_1 = queryParamsList_1.next(); !queryParamsList_1_1.done; queryParamsList_1_1 = queryParamsList_1.next()) {
                    var queryParam = queryParamsList_1_1.value;
                    params = params.append(queryParam.name, queryParam.value);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (queryParamsList_1_1 && !queryParamsList_1_1.done && (_a = queryParamsList_1.return)) _a.call(queryParamsList_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return this.httpService.post('/relations/traverse', null, { params: params });
        };
        return RelationRest;
    }());
    /** @nocollapse */ RelationRest.ɵfac = function RelationRest_Factory(t) { return new (t || RelationRest)(i0__namespace.ɵɵinject(i1__namespace.HttpClient)); };
    /** @nocollapse */ RelationRest.ɵprov = i0__namespace.ɵɵdefineInjectable({ token: RelationRest, factory: RelationRest.ɵfac });
    /*@__PURE__*/ (function () {
        i0__namespace.ɵsetClassMetadata(RelationRest, [{
                type: i0.Injectable
            }], function () { return [{ type: i1__namespace.HttpClient }]; }, null);
    })();
    /**
    *	@generator rest2ts
    *	javaType: inc.yukawa.chain.crm.partner.service.rest.ReminderRest <br/>
    */
    var ReminderRest = /** @class */ (function () {
        function ReminderRest(httpService) {
            this.httpService = httpService;
        }
        return ReminderRest;
    }());
    /** @nocollapse */ ReminderRest.ɵfac = function ReminderRest_Factory(t) { return new (t || ReminderRest)(i0__namespace.ɵɵinject(i1__namespace.HttpClient)); };
    /** @nocollapse */ ReminderRest.ɵprov = i0__namespace.ɵɵdefineInjectable({ token: ReminderRest, factory: ReminderRest.ɵfac });
    /*@__PURE__*/ (function () {
        i0__namespace.ɵsetClassMetadata(ReminderRest, [{
                type: i0.Injectable
            }], function () { return [{ type: i1__namespace.HttpClient }]; }, null);
    })();

    var CrmRealm = /** @class */ (function (_super) {
        __extends(CrmRealm, _super);
        function CrmRealm() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return CrmRealm;
    }(chainMainAngularCore.MainRealm));
    CrmRealm.ROLE_CRM_ADMIN = "ROLE_CRM_ADMIN";
    CrmRealm.ROLE_CRM_EDITOR = "ROLE_CRM_EDITOR";
    CrmRealm.ROLE_CRM_READER = "ROLE_CRM_READER";
    CrmRealm.ROLE_PARTNER_ADMIN = "ROLE_PARTNER_ADMIN";
    CrmRealm.ROLE_PARTNER_EDITOR = "ROLE_PARTNER_EDITOR";
    CrmRealm.ROLE_PARTNER_READER = "ROLE_PARTNER_READER";
    CrmRealm.ROLE_CONTACTLOG_ADMIN = "ROLE_CONTACTLOG_ADMIN";
    CrmRealm.ROLE_CONTACTLOG_EDITOR = "ROLE_CONTACTLOG_EDITOR";
    CrmRealm.ROLE_CONTACTLOG_READER = "ROLE_CONTACTLOG_READER";
    CrmRealm.ROLE_RELATION_ADMIN = "ROLE_RELATION_ADMIN";
    CrmRealm.ROLE_RELATION_EDITOR = "ROLE_RELATION_EDITOR";
    CrmRealm.ROLE_RELATION_READER = "ROLE_RELATION_READER";
    CrmRealm.ROLE_REMINDER_ADMIN = "ROLE_REMINDER_ADMIN";
    CrmRealm.ROLE_REMINDER_EDITOR = "ROLE_REMINDER_EDITOR";
    CrmRealm.ROLE_REMINDER_READER = "ROLE_REMINDER_READER";
    CrmRealm.ADMINS = [chainBaseAngularDomain.BaseRealm.ROLE_ADMIN, CrmRealm.ROLE_CRM_ADMIN];
    CrmRealm.EDITORS = __spread(CrmRealm.ADMINS, [CrmRealm.ROLE_CRM_EDITOR]);
    CrmRealm.READERS = __spread(CrmRealm.EDITORS, [CrmRealm.ROLE_CRM_READER]);
    CrmRealm.PARTNER_EDITORS = __spread(CrmRealm.EDITORS, [CrmRealm.ROLE_PARTNER_EDITOR]);
    CrmRealm.PARTNER_READERS = __spread(CrmRealm.READERS, CrmRealm.PARTNER_EDITORS, [CrmRealm.ROLE_PARTNER_READER]);

    // modules
    // services
    var CRMCoreModule = /** @class */ (function () {
        function CRMCoreModule() {
        }
        CRMCoreModule.forRoot = function () {
            return {
                ngModule: CRMCoreModule,
                providers: [
                    AccountService, ContactLogService, RelationService, RelationConfigService
                ]
            };
        };
        return CRMCoreModule;
    }());
    /** @nocollapse */ CRMCoreModule.ɵmod = i0__namespace.ɵɵdefineNgModule({ type: CRMCoreModule });
    /** @nocollapse */ CRMCoreModule.ɵinj = i0__namespace.ɵɵdefineInjector({ factory: function CRMCoreModule_Factory(t) { return new (t || CRMCoreModule)(); }, providers: [], imports: [[
                common.CommonModule,
                i1.HttpClientModule,
                i1$1.TranslateModule.forChild()
            ]] });
    (function () {
        (typeof ngJitMode === "undefined" || ngJitMode) && i0__namespace.ɵɵsetNgModuleScope(CRMCoreModule, { imports: [common.CommonModule,
                i1.HttpClientModule, i1__namespace$1.TranslateModule] });
    })();
    /*@__PURE__*/ (function () {
        i0__namespace.ɵsetClassMetadata(CRMCoreModule, [{
                type: i0.NgModule,
                args: [{
                        imports: [
                            common.CommonModule,
                            i1.HttpClientModule,
                            i1$1.TranslateModule.forChild()
                        ],
                        declarations: [],
                        exports: [],
                        providers: [],
                        entryComponents: [],
                        schemas: [i0.CUSTOM_ELEMENTS_SCHEMA]
                    }]
            }], null, null);
    })();

    /*
     * Public API
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AccountService = AccountService;
    exports.AccountUtilities = AccountUtilities;
    exports.AddressUtils = AddressUtils;
    exports.CRMCoreModule = CRMCoreModule;
    exports.ContactLogRest = ContactLogRest;
    exports.ContactLogService = ContactLogService;
    exports.CrmRealm = CrmRealm;
    exports.PartnerImportRest = PartnerImportRest;
    exports.PartnerRest = PartnerRest;
    exports.PartnerTemplateRest = PartnerTemplateRest;
    exports.RelationConfigService = RelationConfigService;
    exports.RelationRest = RelationRest;
    exports.RelationService = RelationService;
    exports.ReminderRest = ReminderRest;
    exports.contactLogStatus = contactLogStatus;
    exports.partnerTypes = partnerTypes$1;
    exports.relationRoles = relationRoles;
    exports.relationsConfig = relationsConfig;
    exports.sortByCompanyName = sortByCompanyName;
    exports.sortByLastName = sortByLastName;
    exports.withId = withId;
    exports.withType = withType;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=yukawa-chain-crm-angular-core.umd.js.map
