export declare enum PartnerType {
    COMPANY = "company",
    PERSON = "person"
}
export declare enum ContactLogStatus {
    NEW = "New",
    DONE = "Done",
    ARCHIVED = "Archived",
    PENDING = "Pending"
}
export declare const partnerTypes: string[];
export declare const contactLogStatus: string[];
export interface RelationConfig {
    source: PartnerType;
    target: PartnerType;
    role: string;
    relation: string;
    inverseRelation: string;
    perspective?: 'source' | 'target';
}
